using System;
using Games.TowerLib;
using StpWatchLib;
// Select a project node in Solution Explorer, 
// and then, on the Project TestTowerLib, click Properties. When the Project Designer appears, click the Application tab.
// click the Application tab.
// Startup object: You also have to define a public 
// static void Main() method in a class in the project. 
// This class will appear in the Startup object list as 3 classes:
// TestTowerLib.TestTower0
// TestTowerLib.TestTower1
// TestTowerLib.TestTower2
// You can then select the class as the startup object. 
namespace TestTowerLib
{
    class TestTower2
    {
        static void Main(string[] args)
        {

            int numRigs; // ligal value from 1 to 9
            Console.WriteLine("Enter number of rings to move from A to C");
            Console.WriteLine("The legal value of rings must be in range from 1 to 9");
            numRigs = int.Parse(Console.ReadLine());
            while (numRigs > 9 || numRigs < 1)
            {
                Console.Write("{0} Illegal legal value of rings. Enter new value: ", numRigs);
                numRigs = int.Parse(Console.ReadLine());
            }
            Tower[] towers = new Tower[3];
            towers[0] = new Tower(numRigs, "A");
            towers[1] = new Tower("B");
            towers[2] = new Tower("C");
            Console.WriteLine("Press enter to start solution and start watch");
            Console.ReadLine();
            StpWatch.Start();
            HanoiTowersSolution(towers, numRigs, 0, 2);
            Console.WriteLine("The solution takes {0} seconds", StpWatch.Stop());
            


        }
        private static void HanoiTowersSolution(Tower[] towers, int nRings, int fromPole, int toPole)
        {
            int extraPole;
            if (nRings > 0)
            {
                extraPole = 3 - (fromPole + toPole);
                HanoiTowersSolution(towers, nRings - 1, fromPole, extraPole);
                towers[fromPole].MoveDisc(towers[toPole]);
                HanoiTowersSolution(towers, nRings - 1, extraPole, toPole);
            }

        }
    }
}
